/* Example 11-1.c */
#include <stdio.h>

int clear_bit(int, int);
int set_bit(int, int);
int check_bit(int, int);
void print_bits(int);

int main()
{
    int x;

    x = 123;
    print_bits(x);
    x = clear_bit(x,0);
    print_bits(x);
    x = set_bit(x,12);
    print_bits(x);

    return(0);
}

int clear_bit(int val, int bit)
{
    int mask;
    mask = 1 << bit;
    val &= ~mask;
    return(val);
}

int set_bit(int val, int bit)
{
    int mask;
    mask = 1 << bit;
    val |= mask;
    return (val);
}

int check_bit(int val, int bit)
{
    int mask;
    mask = 1 << bit;
    val &= mask;
    return(val);
}

void print_bits(int val)
{
    int bit;
    for (bit = 31; bit >= 0; bit--) {
        putchar((check_bit(val, bit) ? '1' : '0'));
    }
    printf("\n");
}
